#define	N (sizeof(unsigned) * 8)

unsigned rot(unsigned val, int n)
{
	return n > 0 ? val << n | val >> (N - n)
		    : val >> -n | val << ((N + n) & (N - 1));
}

unsigned s2b(char *s)
{
	unsigned n;
	for (n = 0; *s > ' '; n |= *s++ & 1)
		n <<= 1;
	return n;
}

char *b2s(unsigned n, char *s)
{
	int i;
	s[N] = '\0';
	for (i = N - 1; i >= 0; n >>= 1)
		s[i--] = (n & 1) | '0';
	return s;
}

#include <stdio.h>

int main()
{
	int i;
	unsigned n;
	char s[N + 1];

	fgets(s, N + 1, stdin);
	n = s2b(s);
	puts("");
	for (i = 0; i < N; i++) {
		printf("%s\t", b2s(rot(n,  i), s));
		printf("%s\n", b2s(rot(n, -i), s));
	}
	return 0;
}
