#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

ssize_t getrandom(void *, size_t, unsigned);

#define SIZE	20

#ifdef __amd64__
# define ATTRIB __attribute__((sysv_abi))
#else
# define ATTRIB
#endif

void ATTRIB inssort(long long *, size_t);
int  ATTRIB binsrch(long long, long long *, size_t);

int main()
{
	long long a[SIZE], t;
	int i;

	setvbuf(stdin, NULL, _IONBF, 0);
	setvbuf(stdout, NULL, _IONBF, 0);
#if defined __APPLE__ || defined __OpenBSD__
        arc4random_buf(a, sizeof(a));
#else
	getrandom(a, sizeof(a), 0);
#endif
	inssort(a, SIZE);
	for (i = 0; i < SIZE; i++)
		printf("%2d: %20lld\n", i, a[i]);
	printf("Search for? ");
	if (scanf("%lld", &t) == 1) {
		if ((i = binsrch(t, a, SIZE)) == -1)
			printf("Not found!\n");
		else
			printf("Found at index %d\n", i);
	}
#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
