#include <sys/types.h>
#include <immintrin.h>

ssize_t getrandom(void *buf, size_t buflen, unsigned flags)
{
	unsigned long i;

	for (i = 0; i < buflen / sizeof(unsigned long long); i++)
		while (!_rdrand64_step(&((unsigned long long *)buf)[i]))
			;
	return (ssize_t)buflen;
}

static long long x = 0x1234ABCD330E;

long mrand48()
{
	return (long)((x = x * 0x5DEECE66D + 0xB) >> 16 & 0xFFFFFFFF);
}

void srand48(long s)
{
	x = s << 16 | 0x330E;
}
