; Return in RAX the least common multiple (LCM) of the numbers in RDI and RSI

option prologue:none, epilogue:none
.code
lcmult	proc
_lcmult	proc
	MOV	RAX,RDI	; save A
	MUL	RSI	; RDX:RAX = A * B
	CALL	GCD	; RDI = the greatest common divisor GCD(A, B)
	DIV	RDI	; RAX = A * B / GCD(A, B) = LCM
	RET		; (a divide overflow is possible, despite that GCD > 0)
_lcmult	endp
lcmult	endp
include	gcdivis.s
end
