; Return in the RAX register the quotient, and write at the address passed in
; the RCX register the reminder of the division of the number in the RSI:RDI
; registers to the number in the RDX register.

option prologue:none, epilogue:none
.code
udiv128	proc
_udiv128 proc
	XCHG	RAX,RDI		; RSI:RAX = dividend
	XCHG	RDX,RSI		; RDX:RAX = dividend, RSI = divisor
	DIV	RSI		; In x64 dividend is 2x the size of the divisor
	MOV	[RCX],RDX	; Write the remainder
	RET			; Return the quotient in RAX
_udiv128 endp
udiv128	endp
end
